/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.cacertificateverifier;

import java.io.FileInputStream;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;

/**
 *
 * @author omozegieaziegbe
 */
public class CACertificateVerifier {

    public static void main(String[] args) {
        try {
            // Load the certificate from a file
            //FileInputStream fis = new FileInputStream("path/to/certificate.cer");
            FileInputStream fis = new FileInputStream("/Users/omozegieaziegbe/Downloads/gtsroot.cer");
            CertificateFactory certificateFactory = CertificateFactory.getInstance("X.509");
            X509Certificate certificate = (X509Certificate) certificateFactory.generateCertificate(fis);

            // Check if the certificate is a CA certificate
            boolean isCACertificate = isCACertificate(certificate);

            // Display the result
            if (isCACertificate) {
                System.out.println("The certificate is a CA certificate.");
            } else {
                System.out.println("The certificate is not a CA certificate.");
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    // Method to check if a certificate is a CA certificate
    private static boolean isCACertificate(X509Certificate certificate) {
        boolean isCACertificate = false;

        // Check KeyUsage Extension
        boolean[] keyUsage = certificate.getKeyUsage();
        if (keyUsage != null && keyUsage.length > 5 && keyUsage[5]) {
            // The 6th bit (index 5) corresponds to keyCertSign
            isCACertificate = true;
        }

        // Check BasicConstraints Extension
        if (certificate.getBasicConstraints() != -1) {
            isCACertificate = true;
            System.out.println(" IssuerDN is " + certificate.getIssuerDN());
        }

        return isCACertificate;
    }
}
